import { Component, OnInit } from '@angular/core';
import { ToastrService } from 'ngx-toastr';
import { AlertService } from 'src/app/services/alert.service';
import { Adv5service} from './Adv5.service';
import { AbstractControl, FormArray, FormBuilder, FormGroup, Validators, ValidationErrors } from '@angular/forms';
import { ExtensionService } from 'src/app/services/fnd/extension.service';
import { DashboardContentModel2 } from 'src/app/models/builder/dashboard'; 
import { Adv5cardvariable } from './Adv5_cardvariable';
import { UserInfoService } from 'src/app/services/user-info.service';
declare var JsBarcode: any; 
@Component({
  selector: 'app-Adv5',
  templateUrl: './Adv5.component.html',
  styleUrls: ['./Adv5.component.scss']
})
export class Adv5Component implements OnInit {
  cardButton = Adv5cardvariable.cardButton;
  cardmodeldata = Adv5cardvariable.cardmodeldata;
  public dashboardArray: DashboardContentModel2[];
  isCardview = Adv5cardvariable.cardButton;
  cardmodal;  changeView(){
  this.isCardview = !this.isCardview;
  }
    beforeText(fieldtext: string): string { // Extract the text before the first '<'
    const index = fieldtext.indexOf('<');
    return index !== -1 ? fieldtext.substring(0, index) : fieldtext;
  }
  afterText(fieldtext: string): string { // Extract the text after the last '>'
    const index = fieldtext.lastIndexOf('>');
    return index !== -1 ? fieldtext.substring(index + 1) : '';
  }
  transform(fieldtext: string): string {
    const match = fieldtext.match(/<([^>]*)>/);
    return match ? match[1] : ''; // Extract the text between '<' and '>'
  }
 userrole;
  rowSelected :any= {};
  modaldelete=false;
  modalEdit=false;
  modalAdd= false;
  public entryForm: FormGroup;
  loading = false;
  product;
  modalOpenedforNewLine = false;
  newLine:any;
 additionalFieldsFromBackend: any[] = [];
  formcode = 'Adv5_formCode'
tableName = 'Adv5';  checkFormCode; selected: any[] = []; constructor(
    private extensionService: ExtensionService,
private userInfoService:UserInfoService,
    private mainService:Adv5service,
    private alertService: AlertService,
    private toastr: ToastrService,
    private _fb: FormBuilder,
  ) { }
// component button 
  ngOnInit(): void {
    if(this.cardmodeldata !== ''){
     this.cardmodal = JSON.parse(this.cardmodeldata);
    this.dashboardArray = this.cardmodal.dashboard.slice();
    console.log(this.dashboardArray)
    }
    this.userrole=this.userInfoService.getRoles();
    this.getData();
    this.entryForm = this._fb.group({
name : [null],

support: this._fb.array([this.initLinesForm()]),

age : [null,[Validators.required]],

age2 : [null,[Validators.required]],










 















  }); // component_button200
 // form code start
    this.extensionService.getJsonObjectsByFormCodeList(this.formcode).subscribe(data => {
      console.log(data);
      const jsonArray = data.map((str) => JSON.parse(str));
      this.additionalFieldsFromBackend = jsonArray;
      this.checkFormCode = this.additionalFieldsFromBackend.some(field => field.formCode === "Adv5_formCode");
      console.log(this.checkFormCode);
      console.log(this.additionalFieldsFromBackend);
      if (this.additionalFieldsFromBackend && this.additionalFieldsFromBackend.length > 0) {
        this.additionalFieldsFromBackend.forEach(field => {
          if (field.formCode === this.formcode) {
            if (!this.entryForm.contains(field.extValue)) {
              // Add the control only if it doesn't exist in the form
              this.entryForm.addControl(field.extValue, this._fb.control(field.fieldValue));
            }
          }
        });
      }
    });
    console.log(this.entryForm.value);
    // form code end 

















  }


// one to many start
 initLinesForm() {    return this._fb.group({ 


 	
 Description: [null],
 

 	
 Name: [null],
 


});  }  
get controls() {return (this.entryForm.get("support") as FormArray).controls;  }
onAddLines() {
(<FormArray>this.entryForm.get("support")).push(this.initLinesForm());  }
onRemoveLines(index: number) {
(<FormArray>this.entryForm.get("support")).removeAt(index);  }
 oneditLines() {    this.components.push({ 

 
Description: "",
 

 
Name: "",
 


	  });  }  
 deleteRow(index) {
 this.components.splice(index, 1); 
 }  
		 components;
 // one to many end 













 error; 
  getData() {
    this.mainService.getAll().subscribe((data) => {
      console.log(data);
      this.product = data;
 if(this.product.length==0){
        this.error="No Data Available"
     }   
    },(error) => {
      console.log(error);
      if(error){
       this.error="Server Error";
     }
    });
  }
  onEdit(row) {
    this.rowSelected = row;


this.components = row.support;





//calculated field start
	
 
	   this.additionage= row.age;
	  

 
	   this.additionage2= row.age2;
	  

//calculated field end

//calculated field start
	
 
	   this.subtrationage= row.age;
	  

 
	   this.subtrationage2= row.age2;
	  

//calculated field end






    this.modalEdit = true;
  }
   onDelete(row) {
    this.rowSelected = row;
     this.modaldelete=true;
  }
  delete(id)
  {
    this.modaldelete = false;
    console.log("in delete  "+id);
    this.mainService.delete(id).subscribe(
      (data) => {
        console.log(data);
        this.ngOnInit();
  if (data) {				      this.toastr.success('Deleted successfully');      }
    });
  }
    onUpdate(id) {
    this.modalEdit = false;








//calculated field start
	
 
this.rowSelected.age= this.additionage;
	 

 
this.rowSelected.age2= this.additionage2;
	 

this.onInputChangeaddition ();
 //calculated field end

//calculated field start
	
 
this.rowSelected.age= this.subtrationage;
	 

 
this.rowSelected.age2= this.subtrationage2;
	 

this.onInputChangesubtration ();
 //calculated field end





    //console.log("in update");
    console.log("id  " + id);
    console.log(this.rowSelected);
    //console.log("out update");
    this.mainService.update(id, this.rowSelected).subscribe(
      (data) => {
        console.log(data);
        if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Update Successfully");
        }
setTimeout(() => {
      this.ngOnInit();
    }, 500);
















      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("update Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Updated");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Updated");
        }
      });
    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  } 
onCreate() {
     this.modalAdd=false;








//calculated field start
	
 
this.entryForm.value.age  = this.additionage ;
	  

 
this.entryForm.value.age2  = this.additionage2 ;
	  

//calculated field end

//calculated field start
	
 
this.entryForm.value.age  = this.subtrationage ;
	  

 
this.entryForm.value.age2  = this.subtrationage2 ;
	  

//calculated field end





  this.mainService.create(this.entryForm.value).subscribe(
    (data) => {
      console.log(data);
  if (data || data.status >= 200 && data.status <= 299) {
          this.toastr.success("Added Successfully");
        }
setTimeout(() => {
      this.ngOnInit();
    }, 500);
















      }, (error) => {
        console.log(error);
        if (error.status >= 200 && error.status <= 299) {
          // this.toastr.success("Added Succesfully");
        }
        if (error.status >= 400 && error.status <= 499) {
          this.toastr.error("Not Added");
        }
        if (error.status >= 500 && error.status <= 599) {
          this.toastr.error("Not Added");
        }
      });
    setTimeout(() => {
      this.ngOnInit();
    }, 500);
  }
  goToAdd(row) {
this.modalAdd = true; this.submitted = false;







  //calculated field start

  
 
  this.additionage  = '';
 

 
  this.additionage2  = '';
 



  this.additiontotal = '';

  //calculated field end

  //calculated field start

  
 
  this.subtrationage  = '';
 

 
  this.subtrationage2  = '';
 



  this.subtrationtotal = '';

  //calculated field end






  }
 submitted = false;
onSubmit() {
  console.log(this.entryForm.value);
 this.submitted = true;
  if (this.entryForm.invalid) {
    return;
  }this.onCreate();

} 








 // calculated field code start 

 
 additionage; 
  

 
 additionage2; 
  

  additiontotal ; 
 additioncalculateOperators = "Addition"
onInputChangeaddition() {
const lastObj = 0
const lastObjstring = ''
	
 

    const age= this.additionage|| '';

	const ageValue = parseFloat(this.additionage) || 0;

	  

 

    const age2= this.additionage2|| '';

	const age2Value = parseFloat(this.additionage2) || 0;

	  

if (this.additioncalculateOperators =="Addition") {
 this.additiontotal = (   
	
 
		 ageValue +
	 

 
		 age2Value +
	 
 lastObj).toString();
}
if (this.additioncalculateOperators == "Subtraction") {
	 this.additiontotal = (   

 
 ageValue   -
	 

 
 age2Value   -
	 

	lastObj).toString();
}
if (this.additioncalculateOperators =="Multiplication") {
  this.additiontotal = (

	
 
	ageValue *
		 

 
	age2Value *
		 

lastObj).toString();
}
if (this.additioncalculateOperators =="Division") {
 
	this.additiontotal = ( 

 
ageValue   /
	 

 
age2Value   /
	 

lastObj).toString();

}
if (this.additioncalculateOperators =="Concatination") {
 this.additiontotal =  

 
age+ ' '+
	 

 
age2+ ' '+
	 
 lastObjstring 
}
}

 // calculated field code start 

 
 subtrationage; 
  

 
 subtrationage2; 
  

  subtrationtotal ; 
 subtrationcalculateOperators = "Multiplication"
onInputChangesubtration() {
const lastObj = 0
const lastObjstring = ''
	
 

    const age= this.subtrationage|| '';

	const ageValue = parseFloat(this.subtrationage) || 0;

	  

 

    const age2= this.subtrationage2|| '';

	const age2Value = parseFloat(this.subtrationage2) || 0;

	  

if (this.subtrationcalculateOperators =="Addition") {
 this.subtrationtotal = (   
	
 
		 ageValue +
	 

 
		 age2Value +
	 
 lastObj).toString();
}
if (this.subtrationcalculateOperators == "Subtraction") {
	 this.subtrationtotal = (   

 
 ageValue   -
	 

 
 age2Value   -
	 

	lastObj).toString();
}
if (this.subtrationcalculateOperators =="Multiplication") {
  this.subtrationtotal = (

	
 
	ageValue *
		 

 
	age2Value *
		 

lastObj).toString();
}
if (this.subtrationcalculateOperators =="Division") {
 
	this.subtrationtotal = ( 

 
ageValue   /
	 

 
age2Value   /
	 

lastObj).toString();

}
if (this.subtrationcalculateOperators =="Concatination") {
 this.subtrationtotal =  

 
age+ ' '+
	 

 
age2+ ' '+
	 
 lastObjstring 
}
}

//Value List field start    
valuelistMode;
searchcusttextvalue_list_field :any;    
 valueListModalvalue_list_field :boolean=false;
    openvalueListvalue_list_field(mode){
 this.valueListModalvalue_list_field=!this.valueListModalvalue_list_field ; 
      this.valuelistMode = mode;     }
     customerdatavalue_list_field ;     
cutomererror;
   clickedID:number;

getcustvalue_list_fieldID(id:number){    
 this.clickedID=id;
						    console.log("clicked by id"+ id);
						    this.mainService.getById(id).subscribe((data) => {       console.log(data);
						         if(this.valuelistMode == "ADD"){ 

							
 
							this.entryForm.get('age').setValue(data.age);
							 


						}else if(this.valuelistMode == "EDIT"){

							
 
							this.rowSelected.age= data. age
							 


						}       });       this.valueListModalvalue_list_field =false;
						    }    //value List field end 

//Value List field start    
valuelistMode;
searchcusttextvalue_list_field2 :any;    
 valueListModalvalue_list_field2 :boolean=false;
    openvalueListvalue_list_field2(mode){
 this.valueListModalvalue_list_field2=!this.valueListModalvalue_list_field2 ; 
      this.valuelistMode = mode;     }
     customerdatavalue_list_field2 ;     
cutomererror;
   clickedID:number;

getcustvalue_list_field2ID(id:number){    
 this.clickedID=id;
						    console.log("clicked by id"+ id);
						    this.mainService.getById(id).subscribe((data) => {       console.log(data);
						         if(this.valuelistMode == "ADD"){ 

							
 
							this.entryForm.get('name').setValue(data.name);
							 

 
							this.entryForm.get('age2').setValue(data.age2);
							 

 
							this.entryForm.get('age').setValue(data.age);
							 


						}else if(this.valuelistMode == "EDIT"){

							
 
							this.rowSelected.name= data. name
							 

 
							this.rowSelected.age2= data. age2
							 

 
							this.rowSelected.age= data. age
							 


						}       });       this.valueListModalvalue_list_field2 =false;
						    }    //value List field end 

// updateaction
}















